/**
 * Created by lcg on 16/8/31.
 */

'use strict';

import { exists } from 'react-native-omfs';
import utils from './utils';

const SQLite = require('react-native-sqlite-storage');
const db = SQLite.openDatabase('FileCache.db', "1.0", "filecache", 200000, null, null);

class CacheManager {
    constructor(){
        db.transaction((tx) => {
            tx.executeSql('create table if not exists file (uri varchar(500) primary key, path varchar(500), type varchar(20))', [], (tx, results) => {

            });
        });

    }

    getPath(uri){
        let self = this;
        return new Promise((resolve) => {
            db.transaction((tx) => {
                tx.executeSql('select * from file where uri =\'' + uri + '\'', [], (tx, results) => {
                    let fileCache = null;
                    if(results.rows.length > 0){
                        fileCache = results.rows.item(0);
                    }
                    if (fileCache){
                        exists(fileCache.path)
                            .then((info) => {
                                if (info.exists){
                                    resolve(fileCache.path);
                                }
                                else {
                                    db.transaction((tx) => {
                                        tx.executeSql('delete from file where uri = \'' + uri + '\'', [], (tx, results) => {
                                            resolve();
                                        });
                                    });
                                }
                            });
                    }
                    else {
                        resolve();
                    }
                });
            });
        });
    }

    getList(type) {
        let self = this;
        let sql = '';

        if (type == null){
            sql = 'select * from file';
        }
        else {
            sql = `select * from file where type='${type}'`;
        }

        return new Promise((resolve,reject) => {
            db.transaction((tx) => {
                tx.executeSql(sql, [], (tx, results) => {
                    const files = results.rows.raw().map(row => row);
                    resolve(files);
                },(err) => {
                    reject(err);
                });
            });
        });
    }

    addPath(uri,path,type){
        let self = this;
        return new Promise((resolve,reject) => {
            db.transaction((tx) => {
                tx.executeSql('insert into file values (\'' + uri + '\',\'' + path + '\',\'' + type + '\')', [], (tx, results) => {
                    resolve(path);
                },(err) => {
                    reject(err);
                });
            });
        });
    }

    removePath(uri) {
        let self = this;
        return new Promise((resolve) => {
            db.transaction((tx) => {
                tx.executeSql('delete from file where uri = \'' + uri + '\'', [], (tx, results) => {
                    resolve();
                });
            });
        });
    }

    removeType(type){
        let self = this;
        return new Promise((resolve) => {
            db.transaction((tx) => {
                tx.executeSql('delete from file where type = \'' + type + '\'', [], (tx, results) => {
                    resolve();
                });
            });
        });
    }
}

export default new CacheManager();