/**
 * Created by lcg on 16/9/2.
 */

'use strict';

import { exists, mkdir, CacheDir } from 'react-native-omfs';
import utils from './utils';

export const cacheDir = function(type){
    let dir = CacheDir + '/cache';

    if (utils.isString(type)){
        dir += '/' + type;
    }

    return dir;
};

export const generatePath = function(taskId, type){
    let rootDir = cacheDir(type);

    return exists(rootDir)
        .then((exists) => {
            if(exists){
                return rootDir;
            }
            else {
                return mkdir(rootDir);
            }
        })
        .then(() => {
            return (rootDir + '/' + taskId);
        });
};

