/**
 * Created by lcg on 16/8/31.
 */

'use strict';

function objectToString(o) {
    return Object.prototype.toString.call(o);
}

export default {
    isNullOrUndefined(obj){
        return obj == null;
    },

    isString(arg) {
        return typeof arg === 'string';
    },

    //conflict with android,remove.
    //isObject(arg) {
    //    return typeof arg === 'object' && arg !== null;
    //},

    isArray(ar) {
        return Array.isArray(ar);
    },

    isBoolean(arg) {
        return typeof arg === 'boolean';
    },

    isNull(arg) {
        return arg === null;
    },

    isNumber(arg) {
        return typeof arg === 'number';
    },

    isSymbol(arg) {
        return typeof arg === 'symbol';
    },

    isUndefined(arg) {
        return arg === void 0;
    },

    isObject(arg) {
        return typeof arg === 'object' && arg !== null;
    },

    isRegExp(re) {
        return isObject(re) && objectToString(re) === '[object RegExp]';
    },

    isDate(d) {
        return isObject(d) && objectToString(d) === '[object Date]';
    },

    isError(e) {
        return isObject(e) &&
            (objectToString(e) === '[object Error]' || e instanceof Error);
    },

    isFunction(arg) {
        return typeof arg === 'function';
    },

    startWith(str,pre){
        var reg=new RegExp("^"+pre);
        return reg.test(str);
    },

    endWith(str,pre){
        var reg=new RegExp(pre + "$");
        return reg.test(str);
    },

    encode(uri){
        const isEncoded = decodeURI(uri) !== uri;
        return isEncoded ? uri : encodeURI(uri);
    }

}